<script setup lang="ts">
import AForm from '@/components/AForm/index.vue'
import { FormConfigType } from '@/components/AForm/type'
import { ToolbarConfigType } from '@/components/AToolbar/type'
import { ColumnConfigType } from '@/components/ATable/type'
import { StrAnyObj, StrAnyObjArr } from '@/typings'
import { useHandleData } from '@/utils/useHandleData'
import { getPageApi, getDetailApi, addApi, editApi, deleteApi } from '@/api/business/corporation/shop'
import { getPageApi as getCorporationPageApi } from '@/api//business/corporation/corporation'
import UserOperation from '@/views/business/log/userOperation/index.vue'

const queryRef = ref<InstanceType<typeof AForm>>()
const formRef = ref<InstanceType<typeof AForm>>()

const showQuery = ref<boolean>(true)
const selectKeys = ref<string[]>([])
const pageTotal = ref<number>(0)

const queryData = ref<StrAnyObj>({ pageNum: 1, pageSize: 10 })
const tableData = ref<StrAnyObjArr>([])
const formData = ref<StrAnyObj>({})
const logData = ref<StrAnyObj>({})
const operationLog = ref<boolean>(false)

const dialogTitle = ref<string>('')
const dialogVisible = ref<boolean>(false)

const queryConfig: FormConfigType[] = [
  {
    type: 'input',
    prop: 'name',
    label: '店铺名称'
  },
  {
    type: 'select',
    prop: 'corporationId',
    label: '归属公司',
    option: async () => (await getCorporationPageApi({ searchAll: true })).records,
    keyName: 'id',
    labelName: 'name'
  }
]

const toolbarConfig: ToolbarConfigType[] = [
  {
    common: 'search',
    click() {
      queryData.value.pageNum = 1
      getPage()
    }
  },
  {
    common: 'reset',
    click() {
      queryRef.value?.resetFields()
      getPage()
    }
  },
  {
    common: 'add',
    click() {
      dialogVisible.value = true
      dialogTitle.value = '新增'
    }
  },
  {
    common: 'delete',
    disabled() {
      return selectKeys.value.length == 0
    },
    click() {
      handleRemove(selectKeys.value)
    }
  }
]

const columnConfig: ColumnConfigType[] = [
  {
    prop: 'name',
    label: '店铺名称',
    width: 220
  },
  {
    prop: 'corporationName',
    label: '归属公司',
    width: 220
  },
  {
    prop: 'remark',
    label: '备注'
  },
  {
    prop: 'createTime',
    label: '创建时间',
    width: 220
  },
  {
    width: 220,
    handleConfig: [
      {
        text: '操作日志',
        click(row) {
          logData.value = row
          operationLog.value = true
        }
      },
      {
        common: 'update',
        click(row) {
          dialogVisible.value = true
          dialogTitle.value = '编辑'
          getDetailApi({ id: row.id }).then((resp: StrAnyObj) => {
            formData.value = resp
          })
        }
      },
      {
        common: 'delete',
        click(row) {
          handleRemove([row.id])
        }
      }
    ]
  }
]

const formConfig: FormConfigType[] = [
  {
    type: 'input',
    prop: 'name',
    label: '店铺名称',
    rule: [{ required: true, message: '店铺名称不能为空', trigger: 'blur' }]
  },
  {
    type: 'select',
    prop: 'corporationId',
    label: '归属公司',
    option: async () => (await getCorporationPageApi({ searchAll: true })).records,
    keyName: 'id',
    labelName: 'name',
    rule: [{ required: true, message: '公司id不能为空', trigger: 'blur' }],
    change: (val, options) => {
      if (val) {
        let list = options.filter((item) => item.id === val)
        if (list && list.length > 0) {
          formData.value.corporationName = list[0].name
        } else {
          formData.value.corporationName = ''
        }
      } else {
        formData.value.corporationName = ''
      }
    }
  },
  {
    type: 'input',
    prop: 'remark',
    label: '备注',
    itemType: 'textarea',
    rows: 5
  }
]

onMounted(() => {
  getPage()
})

// function getCorporation() {
//   .then((resp) => {
//
//   })
// }

function getPage() {
  // getCorporation()
  getPageApi(queryData.value).then((resp) => {
    tableData.value = resp.records
    pageTotal.value = resp.total
  })
}

function tableSelectionChange(item: StrAnyObjArr) {
  selectKeys.value = item.map((item) => item.id)
}

function formSubmit() {
  formRef.value?.validate(() => {
    if (formData.value.id) {
      editApi(formData.value).then(() => {
        dialogVisible.value = false
        ElMessage.success('修改成功')
        getPage()
      })
    } else {
      addApi(formData.value).then(() => {
        dialogVisible.value = false
        ElMessage.success('新增成功')
        getPage()
      })
    }
  })
}

function formClosed() {
  formRef.value?.resetFields()
}

function handleRemove(idList: string[]) {
  useHandleData('是否确认删除？', () => {
    deleteApi({ idList }).then(() => {
      ElMessage.success('删除成功')
      getPage()
    })
  })
}
</script>

<template>
  <div>
    <el-card v-if="showQuery">
      <a-form ref="queryRef" v-model="queryData" :config="queryConfig" :span="6"> </a-form>
    </el-card>

    <a-table
      selection
      :data="tableData"
      :page-total="pageTotal"
      :toolbar-config="toolbarConfig"
      :column-config="columnConfig"
      v-model:show-query="showQuery"
      v-model:page-num="queryData.pageNum"
      v-model:page-size="queryData.pageSize"
      @page-num-change="getPage"
      @page-size-change="getPage"
      @selection-change="tableSelectionChange"
    >
    </a-table>

    <a-dialog v-model="dialogVisible" :title="dialogTitle" @submit="formSubmit" @closed="formClosed">
      <a-form ref="formRef" v-model="formData" :config="formConfig" :span="24"> </a-form>
    </a-dialog>

    <a-dialog v-model="operationLog" title="操作日志" width="90%" :footer="false">
      <UserOperation :logData="logData"></UserOperation>
    </a-dialog>
  </div>
</template>
